# -*- coding: utf-8 -*-
# @Author: wangkun
# @Time: 2023/9/6
import os
import sys

sys.path.append(os.getcwd())
from common.common import Common
from zhufuquanzi.zhufuquanzi_recommend.zhufuquanzi_recommend import ZhufuquanziRecommend


class ZhufuquanziRecommendMain:
    @classmethod
    def zhufuquanzi_recommend_main(cls, log_type, crawler, env):
        Common.logger(log_type, crawler).info('开始抓取"祝福圈子"推荐')
        Common.logging(log_type, crawler, env, '开始抓取"祝福圈子"推荐')
        rule_dict = {"period": {"min": 365, "max": 365},
                     "duration": {"min": 30, "max": 1800},
                     "favorite_cnt": {"min": 5000, "max": 0},
                     "videos_cnt": {"min": 10, "max": 20},
                     "share_cnt": {"min": 1000, "max": 0}}
        ZhufuquanziRecommend.start_wechat(log_type=log_type,
                                          crawler=crawler,
                                          rule_dict=rule_dict,
                                          env=env)
        Common.logger(log_type, crawler).info("抓取一轮结束\n")
        Common.logging(log_type, crawler, env, "抓取一轮结束\n")


if __name__ == "__main__":
    ZhufuquanziRecommendMain.zhufuquanzi_recommend_main("recommend", "zhufuquanzi", "dev")
